variable "bucket_name" {
  type = string
}

variable "acl" {
  type    = string
  default = ""
}

variable "enable_bucket_owner_full_control_acl" {
  type    = bool
  default = false
}

variable "block_public_acls" {
  type    = bool
  default = true
}

variable "block_public_policy" {
  type    = bool
  default = true
}

variable "ignore_public_acls" {
  type    = bool
  default = true
}

variable "restrict_public_buckets" {
  type    = bool
  default = true
}

variable "versioning_enabled" {
  type        = bool
  default     = true
  description = "s3 Versioning"
}

variable "tags" {
  type        = map(string)
  description = "Standard Tags for S3 Bucket"
}

variable "additional_tags" {
  type        = map(string)
  default     = {}
  description = "Additional Tags for S3 Bucket"
}

variable "iam_policy_prefix" {
  type = string
}

variable "s3_website_enabled" {
  type    = bool
  default = false
}

variable "s3_website_index_document" {
  type    = string
  default = "index.html"
}

variable "lambda_arn" {
  description = "Arn of Lambda for S3 events"
  type        = string
  default     = ""
}

variable "sqs_arn" {
  description = "Arn of SQS for S3 events"
  type        = string
  default     = ""
}

variable "sns_arn" {
  description = "Arn of SNS for S3 events"
  type        = string
  default     = ""
}

variable "filter_suffix" {
  description = "Suffix for S3 events"
  type        = any
  default     = null
}

variable "filter_prefix" {
  description = "Prefix for S3 events"
  type        = any
  default     = null
}
variable "events" {
  description = "Type of S3 Events for trigger"
  type        = string
  default     = ""
}

variable "lifecycle_rule" {
  description = "List of maps that contain the S3 lifecycle rules"
  type        = any
  default     = []
}

variable "logging_bucket_name" {
  description = "Server Access Logs Bucket Name"
  type        = any
  default     = null
}

variable "logging_prefix" {
  description = "Server Access Logs Prefix"
  type        = any
  default     = "logs/"
}

variable "cors_rule" {
  description = "cors rule for s3 bucket"
  type        = any
  default     = []
}

variable "sse_algorithm" {
  description = "SSE algorithm"
  type        = string
  default     = "AES256"
}

variable "kms_master_key_id" {
  description = "Kms key id for encryption"
  type        = string
  default     = ""
}

variable "enable_iam_policies" {
  type    = bool
  default = true
}